#!/usr/bin/python

import cgi, httplib, time, sys, string, os, os.path


print "Content-type: text/html\n\n"
print "<HTML><HEAD><TITLE>APO4.0 Log</TITLE></HEAD><BODY BGCOLOR=#FFFFFF>\n<H1>"


form = cgi.FieldStorage()

def TranslatePlatform(platform):
    PlatformHash = { 'Solaris' : 'sun_64', 'True64' : 'alphaosf', 'HP-UX' : 'hp_64', 'AIX 5.1' : 'rs6000_64', 'NT, 32 Bit' : 'NTintel', 'NT, 64 Bit' : 'NTia64' }
    try:
        return PlatformHash[platform]
    except:
        return None

def UpdateLCPoolLink(platform, lc_src):
    NewLC_OK = ""
    if platform[:2] == 'NT':
        WinCmd = '/var/www/winLink '
        if platform == 'NTia64':
            WinCmd = WinCmd + '-bit 64 '
        WinCmd = WinCmd + 'LC_OK ' + lc_src
        win_line = string.strip(os.popen (WinCmd).read ())
	if win_line[:9]  == 'Reference':
            NewLC_OK = win_line[19:22]
        else:
            NewLC_OK = "ERR"
    else:
        try:
            LCPoolPath = '/bas/SAP_DB/7403/pkg/' + platform + '/LC_7403_64_DEV/' 
            if lc_src == 'LastTest':
                NewLC_OK = os.readlink (LCPoolPath + lc_src)
            else:
                NewLC_OK = lc_src
            if os.path.exists(LCPoolPath + 'LC_OK'):
                os.unlink(LCPoolPath + 'LC_OK')
            os.symlink(NewLC_OK,LCPoolPath + 'LC_OK')
        except:
            NewLC_OK = "ERR"
    return NewLC_OK
    

def SendMailToLCAPPS(platform, lcpoolnr, comment=''):
    import smtplib

    try:
        frm      = 'automail.releaseLP@sap.com'
        
        to       = 'ivan.schreter@sap.com,peter.goertz@sap.com,markus.sinnwell@sap.com'
        
        cc       = 'gerald.arnold@sap.com,el.houssine.touh@sap.com,carl.seghers@sap.com,holm.kirstein@sap.com,thorsten.duda@sap.com,jan.wedel@sap.com,hans-georg.reusch@sap.com,bernhard.kilgus@sap.com,holger.becker@sap.com'
        
        subject  = 'LC_OK link updated for ' + platform  
        
        msg      = 'LC_OK link updated for ' + platform + "\n"
        msg      = msg + "set LC_OK to " + lcpoolnr + "\n"
        if  (comment != ''):
            msg = msg + "comment: " + comment + "\n"
        msg     = msg + "\n\nDon't reply to this mail because it's generated automatically\n"
        
        body = string.join((
            "From: %s" % frm,
            "To: %s" % to,
            "Cc: %s" % cc,
            "Subject: %s" % subject,
            " ",
            msg), "\r\n")
        
        server = smtplib.SMTP('mail.sap-ag.de')
        server.sendmail(frm, string.splitfields( (to + ',' + cc), ','), body)
        server.quit()
    except:
	pass

def my_exit():
    print "<HR><FONT SIZE=-1><I>Date: " + time.ctime(time.time()) + ', comments to <A HREF="mailto:falko.flessner@sap.com">falko.flessner@sap.com</A></I></FONT></BODY></HTML>'
    sys.exit(0)

if not (form.has_key("platform")):
    print "Platform-Log eintragen</H1>"
    
    print """<FORM ACTION="/note.py" METHOD="post"><TABLE><TR><TD>Bitte Whlen Sie eine Plattform aus:</TD><TD><SELECT NAME="platform" SIZE="1">
    <OPTION VALUE="NT, 32 Bit">NT, 32 Bit</OPTION>
    <OPTION VALUE="NT, 64 Bit">NT, 64 Bit</OPTION>
    <OPTION VALUE="Solaris">Solaris</OPTION>
    <OPTION VALUE="True64">True64</OPTION>
    <OPTION VALUE="AIX 5.1">AIX 5.1</OPTION>
    <OPTION VALUE="AIX 4.3">AIX 4.3</OPTION>
    <OPTION VALUE="HP-UX">HP-UX</OPTION>
    <OPTION VALUE="Allgemeiner Eintrag">Allgemeiner Eintrag</OPTION>
    </SELECT></TD><TR>
    <TR><TD>Bitte whlen Sie den Status aus:</TD><TD>
    <INPUT TYPE="radio" NAME="status" VALUE="OK"> OK,
    <INPUT TYPE="radio" NAME="status" VALUE="NOK"> nicht OK</TD></TR>
    <TR><TD>Mail an LC_APPS versenden:</TD><TD>
    <INPUT TYPE="checkbox" NAME="withmail" VALUE="withmail" checked></TD></TR>
    <TR><TD>LC_POOL Nummer (optional):</TD><TD>
    <INPUT SIZE=4 MAXLENGTH=4 NAME="lc_count"> </TD></TR>
    <TR><TD COLSPAN=2>Kommentare?<BR><TEXTAREA NAME="comment" COLS=70 ROWS=10 WRAP="physical"></TEXTAREA><BR><FONT SIZE=-1>
    (HTML-Tags sind erlaubt)</FONT></TD></TR>
    </TABLE>
    <INPUT TYPE="submit" VALUE="Bitte eintragen">
    """  
else:
    datetup = time.localtime(time.time())[0:3]

    if (form['platform'].value != 'Allgemeiner Eintrag') and not (form.has_key('status')):
        print ('<H3>Fehler in der Daten&uuml;bermittlung</H3>Bitte f&uuml;llen Sie alle Felder aus.<TABLE>')
        for x in form.keys():
            print "<TR><TD VALIGN=top><TT>'" + x + "'</TT></TD><TD>'<TT>" + form[x].value + "'</TT></TD></TR>"
        print "</TABLE>"
        my_exit()
    try:
        logfile = open("/var/www/apo4.html", 'r')
    except:
        print ("<H2>Fehler!</H2>Konnte die Log-Datei nicht &ouml;ffnen :-((")
        my_exit()
    
    mylines = logfile.readlines()
    logfile.close()

    try:
        logfile = open("/var/www/apo4.html", 'w')
    except:
        print ("<H2>Fehler!</H2>Konnte die Log-Datei nicht &ouml;ffnen :-((")
        my_exit()
    
    log_lines = len(mylines)
    outstr = "" 
    
    for x in (range(log_lines)): 
        if (mylines[x][:10] == "<!-- Entry"):
            break
        if not form.has_key('status'):
            outstr = outstr + mylines[x]
            continue
        if (form['status'].value == 'OK') and (mylines[x][:20] == "<!-- LF " + string.ljust(form['platform'].value, 12)):
            outstr = outstr +  "<!-- LF " + string.ljust(form['platform'].value, 14) + ' --><TR><TD><FONT FACE="Arial, Helvetica" SIZE="-1">' + form['platform'].value
            outstr = outstr + '</TD><TD><FONT FACE="Arial, Helvetica" SIZE="-1">' + string.zfill(str(datetup[2]), 2) + "." + string.zfill(str(datetup[1]), 2) + "." + str(datetup[0]) + "</TD></TR>\n"
        else:
            outstr = outstr + mylines[x]
    
    lc_count = 'ERR'
    if (form.has_key('status') and (form['status'].value == "OK")):
        try:
            platform = TranslatePlatform (form['platform'].value)
            if (platform != None):
                if form.has_key("lc_count"):
                     lc_count = UpdateLCPoolLink(platform, form['lc_count'].value)
                else:
                     lc_count = UpdateLCPoolLink(platform, "LastTest")
                if ((lc_count != 'ERR') and (form.has_key('withmail'))):
                    if (form.has_key('comment')):
                        SendMailToLCAPPS(platform, lc_count, form['comment'].value)
                    else:
                        SendMailToLCAPPS(platform, lc_count)
        except:
		pass
		
    outstr = outstr +  '<!-- Entry --><TR><TD><FONT FACE="Arial, Helvetica" SIZE="-1"><B>' + string.zfill(str(datetup[2]), 2) + "." + string.zfill(str(datetup[1]), 2) + "." + str(datetup[0]) + '</TD><TD><FONT FACE="Arial, Helvetica" SIZE="-1"><B>' + form['platform'].value
    outstr = outstr + '</TD><TD><FONT FACE="Arial, Helvetica" SIZE="-1"><B>'
    
    if (form['platform'].value == "Allgemeiner Eintrag"):
        outstr = outstr + "&nbsp;</TD></TR>"
        print '<H3>Daten geschrieben</H3> <A HREF="http://ls0106.wdf.sap-ag.de:1111/apo4.html">see apo4.html</A>'
    elif (form['status'].value != "OK"):
        outstr= outstr + ' <IMG SRC="red.jpg" WIDTH=16 HEIGHT=16 ALT="ROT!"> nicht freigegeben</TD></TR>' 
        print '<H3>Daten geschrieben</H3> <A HREF="http://ls0106.wdf.sap-ag.de:1111/apo4.html">see apo4.html</A>'
    else:
        if (lc_count == 'ERR'):
            outstr = outstr + ' <IMG SRC="red.jpg" WIDTH=16 HEIGHT=16 ALT="GR&Uuml;N!"> freigegeben, aber LC_OK nicht gesetzt</TD><TR>'
            if form.has_key("lc_count"):
                lc_count = form['lc_count'].value
            else:
                lc_count = 'LastTest'
            print "<H3>Daten geschrieben</H3><H2>LC_POOL: Achtung LC_OK nicht auf "+lc_count+' gesetzt</H2> <A HREF="http://ls0106.wdf.sap-ag.de:1111/apo4.html">see apo4.html</A>'
        else:
            outstr = outstr + ' <IMG SRC="green.jpg" WIDTH=16 HEIGHT=16 ALT="GR&Uuml;N!"> freigegeben</TD><TR>'
            print "<H3>Daten geschrieben</H3><H2>LC_POOL: LC_OK =&gt; "+lc_count+'</H2> <A HREF="http://ls0106.wdf.sap-ag.de:1111/apo4.html">see apo4.html</A>'
    
    if (form.has_key('comment') and (string.strip(form['comment'].value) != "")):
        if (form['platform'].value == "Allgemeiner Eintrag"):
            outstr = outstr + '<TR><TD>&nbsp;</TD><TD VALIGN="top"></TD><TD><FONT FACE="Arial, Helvetica" SIZE="-1">' + string.strip(form['comment'].value) + '<BR>&nbsp;</TD></TR>'
        else:
            outstr = outstr + '<TR><TD>&nbsp;</TD><TD VALIGN="top"></TD><TD><FONT FACE="Arial, Helvetica" SIZE="-1">' + 'LC_POOL Nummer = ' + lc_count + '<BR>' + string.strip(form['comment'].value) + '<BR>&nbsp;</TD></TR>'
    else:
        if (form.has_key('status')):
            if (form['status'].value == "OK"):
                outstr = outstr + '<TR><TD>&nbsp;</TD><TD VALIGN="top"></TD><TD><FONT FACE="Arial, Helvetica" SIZE="-1">' + 'LC_POOL Nummer = ' + lc_count + ' freigegeben <BR>&nbsp;</TD></TR>'
            else:
                outstr = outstr + '<TR><TD>&nbsp;</TD><TD VALIGN="top"></TD><TD><FONT FACE="Arial, Helvetica" SIZE="-1">' + 'LC_POOL Nummer = ' + lc_count + ' nicht freigegeben <BR>&nbsp;</TD></TR>'

    outstr = outstr + "\n"
    
    for y in range (x, log_lines):
        outstr = outstr + (mylines[y])
    
    logfile.write(outstr)

    h = httplib.HTTP("pgwdf160.wdf.sap.corp:1080")
    h.putrequest('PUT', "/exchange/nachtlauf/apo4.log")
    h.putheader ('Host', "pgwdf160.wdf.sap.corp:1080")
    h.putheader ('Content-type', 'text/plain')
    h.putheader ('Content-Length', str(len(outstr)))
    h.endheaders()
    h.send(outstr)

    my_exit()
